stages:
  - test
  - publish

image: $IMAGE:$UNITY_VERSION-base-$IMAGE_VERSION

variables:
  UNITY_VERSION: "2020.1.11f1"
  UNITY_DIR: $CI_PROJECT_DIR
  IMAGE: unityci/editor
  IMAGE_VERSION: "0.12"

.unity_before_script: &unity_before_script
  before_script:
    - curl -fsSL https://deb.nodesource.com/setup_16.x | bash -
    - apt-get install -y nodejs
    - npm install -g unity-ci-harness
    - unity-ci-harness init Project
    - unity-ci-harness add-dependencies Project package.json
    - unity-ci-harness expand Project --subdirectory Package
    - chmod +x ./ci/before_script.sh && ./ci/before_script.sh

.test: &test
  stage: test
  <<: *unity_before_script
  script:
    - chmod +x ./ci/test.sh && ./ci/test.sh
    - mv Assets/Package ProcessedPackage
  artifacts:
    paths:
      - $(pwd)/$TEST_PLATFORM-results.xml
      - $(pwd)/$TEST_PLATFORM-coverage/
      - ProcessedPackage/
    expire_in: 1 week
  tags:
    - gitlab-org
  coverage: /<Linecoverage>(.*?)</Linecoverage>/

test:
  <<: *test
  variables:
    TEST_PLATFORM: playmode

publish_package:
  stage: publish
  image: node
  dependencies:
    - test
  only:
    - master
  before_script:
    - npm set //$MANGANESE_PACKAGES_UNITY_REGISTRY/:_authToken=$MANGANESE_PACKAGES_UNITY_TOKEN
    - cd ProcessedPackage
  script:
    - npm publish --registry http://$MANGANESE_PACKAGES_UNITY_REGISTRY -y
